// Récupération des données d'un compteur EDF par Rpi
#include <iostream>
#include <string.h>
#include <errno.h>

#include <wiringPi.h>
#include <wiringSerial.h>
#include <string>
using namespace std;

int main ()
{
  int fd ;

  if (wiringPiSetup () == -1)
  {
	cout<<"Impossible de démarrer wirinPi. Erreur : "<<strerror (errno);
	return 1 ;
  }

  if ((fd = serialOpen ("/dev/ttyAMA0", 1200)) < 0)
  {
 	cout<<"Impossible d'ouvrir le port /dev/ttyAMA0. Erreur : "<<strerror (errno);
	return 1 ;
  }

int Nb_captures=0;
char data[400];

while(1)
	{
	data[0] = serialGetchar(fd);		// Lecture et stockage dans data 
	data[0]&=127;
	if (data[0]=='I')
		{
		data[1] = serialGetchar(fd);		// Lecture et stockage dans data 
		data[1]&=127;
		if (data[1]=='M')
			{
			for (int i(2); i<170; i++)
				{
				data[i] = serialGetchar(fd);		// Lecture et stockage dans data 
				data[i]&=127;
				}
			Nb_captures++;
			cout<<"Capture N° : "<<Nb_captures<<endl;
//			for (int i(0); i<170; i++) cout<<" "<<data[i];
			for (int i(0); i<170; i++) cout<<data[i];
			cout<<endl;
			cout<<endl;
			}
		}
	}

serialFlush(fd);		// Effacement buffers série avant lecture Rx
serialClose(fd);		// Fermeture du port série

return 0 ;
}
